// Copyright 2015 Amazon.com, Inc. or its affiliates. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License"). You may
// not use this file except in compliance with the License. A copy of the
// License is located at
//
//     http://aws.amazon.com/apache2.0/
//
// or in the "license" file accompanying this file. This file is distributed
// on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
// express or implied. See the License for the specific language governing
// permissions and limitations under the License.

// Automatically generated by MockGen. DO NOT EDIT!
// Source: github.com/aws/amazon-ecs-agent/agent/engine (interfaces: TaskEngine,DockerClient)

package mock_engine

import (
	api "github.com/aws/amazon-ecs-agent/agent/api"
	engine "github.com/aws/amazon-ecs-agent/agent/engine"
	statemanager "github.com/aws/amazon-ecs-agent/agent/statemanager"
	go_dockerclient "github.com/fsouza/go-dockerclient"
	gomock "github.com/golang/mock/gomock"
	context "golang.org/x/net/context"
)

// Mock of TaskEngine interface
type MockTaskEngine struct {
	ctrl     *gomock.Controller
	recorder *_MockTaskEngineRecorder
}

// Recorder for MockTaskEngine (not exported)
type _MockTaskEngineRecorder struct {
	mock *MockTaskEngine
}

func NewMockTaskEngine(ctrl *gomock.Controller) *MockTaskEngine {
	mock := &MockTaskEngine{ctrl: ctrl}
	mock.recorder = &_MockTaskEngineRecorder{mock}
	return mock
}

func (_m *MockTaskEngine) EXPECT() *_MockTaskEngineRecorder {
	return _m.recorder
}

func (_m *MockTaskEngine) AddTask(_param0 *api.Task) error {
	ret := _m.ctrl.Call(_m, "AddTask", _param0)
	ret0, _ := ret[0].(error)
	return ret0
}

func (_mr *_MockTaskEngineRecorder) AddTask(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "AddTask", arg0)
}

func (_m *MockTaskEngine) Disable() {
	_m.ctrl.Call(_m, "Disable")
}

func (_mr *_MockTaskEngineRecorder) Disable() *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "Disable")
}

func (_m *MockTaskEngine) Init() error {
	ret := _m.ctrl.Call(_m, "Init")
	ret0, _ := ret[0].(error)
	return ret0
}

func (_mr *_MockTaskEngineRecorder) Init() *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "Init")
}

func (_m *MockTaskEngine) ListTasks() ([]*api.Task, error) {
	ret := _m.ctrl.Call(_m, "ListTasks")
	ret0, _ := ret[0].([]*api.Task)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

func (_mr *_MockTaskEngineRecorder) ListTasks() *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "ListTasks")
}

func (_m *MockTaskEngine) MarshalJSON() ([]byte, error) {
	ret := _m.ctrl.Call(_m, "MarshalJSON")
	ret0, _ := ret[0].([]byte)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

func (_mr *_MockTaskEngineRecorder) MarshalJSON() *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "MarshalJSON")
}

func (_m *MockTaskEngine) MustInit() {
	_m.ctrl.Call(_m, "MustInit")
}

func (_mr *_MockTaskEngineRecorder) MustInit() *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "MustInit")
}

func (_m *MockTaskEngine) SetSaver(_param0 statemanager.Saver) {
	_m.ctrl.Call(_m, "SetSaver", _param0)
}

func (_mr *_MockTaskEngineRecorder) SetSaver(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "SetSaver", arg0)
}

func (_m *MockTaskEngine) TaskEvents() (<-chan api.TaskStateChange, <-chan api.ContainerStateChange) {
	ret := _m.ctrl.Call(_m, "TaskEvents")
	ret0, _ := ret[0].(<-chan api.TaskStateChange)
	ret1, _ := ret[1].(<-chan api.ContainerStateChange)
	return ret0, ret1
}

func (_mr *_MockTaskEngineRecorder) TaskEvents() *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "TaskEvents")
}

func (_m *MockTaskEngine) UnmarshalJSON(_param0 []byte) error {
	ret := _m.ctrl.Call(_m, "UnmarshalJSON", _param0)
	ret0, _ := ret[0].(error)
	return ret0
}

func (_mr *_MockTaskEngineRecorder) UnmarshalJSON(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "UnmarshalJSON", arg0)
}

func (_m *MockTaskEngine) Version() (string, error) {
	ret := _m.ctrl.Call(_m, "Version")
	ret0, _ := ret[0].(string)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

func (_mr *_MockTaskEngineRecorder) Version() *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "Version")
}

// Mock of DockerClient interface
type MockDockerClient struct {
	ctrl     *gomock.Controller
	recorder *_MockDockerClientRecorder
}

// Recorder for MockDockerClient (not exported)
type _MockDockerClientRecorder struct {
	mock *MockDockerClient
}

func NewMockDockerClient(ctrl *gomock.Controller) *MockDockerClient {
	mock := &MockDockerClient{ctrl: ctrl}
	mock.recorder = &_MockDockerClientRecorder{mock}
	return mock
}

func (_m *MockDockerClient) EXPECT() *_MockDockerClientRecorder {
	return _m.recorder
}

func (_m *MockDockerClient) ContainerEvents(_param0 context.Context) (<-chan engine.DockerContainerChangeEvent, error) {
	ret := _m.ctrl.Call(_m, "ContainerEvents", _param0)
	ret0, _ := ret[0].(<-chan engine.DockerContainerChangeEvent)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

func (_mr *_MockDockerClientRecorder) ContainerEvents(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "ContainerEvents", arg0)
}

func (_m *MockDockerClient) CreateContainer(_param0 *go_dockerclient.Config, _param1 *go_dockerclient.HostConfig, _param2 string) engine.DockerContainerMetadata {
	ret := _m.ctrl.Call(_m, "CreateContainer", _param0, _param1, _param2)
	ret0, _ := ret[0].(engine.DockerContainerMetadata)
	return ret0
}

func (_mr *_MockDockerClientRecorder) CreateContainer(arg0, arg1, arg2 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "CreateContainer", arg0, arg1, arg2)
}

func (_m *MockDockerClient) DescribeContainer(_param0 string) (api.ContainerStatus, engine.DockerContainerMetadata) {
	ret := _m.ctrl.Call(_m, "DescribeContainer", _param0)
	ret0, _ := ret[0].(api.ContainerStatus)
	ret1, _ := ret[1].(engine.DockerContainerMetadata)
	return ret0, ret1
}

func (_mr *_MockDockerClientRecorder) DescribeContainer(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "DescribeContainer", arg0)
}

func (_m *MockDockerClient) GetContainerName(_param0 string) (string, error) {
	ret := _m.ctrl.Call(_m, "GetContainerName", _param0)
	ret0, _ := ret[0].(string)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

func (_mr *_MockDockerClientRecorder) GetContainerName(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "GetContainerName", arg0)
}

func (_m *MockDockerClient) InspectContainer(_param0 string) (*go_dockerclient.Container, error) {
	ret := _m.ctrl.Call(_m, "InspectContainer", _param0)
	ret0, _ := ret[0].(*go_dockerclient.Container)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

func (_mr *_MockDockerClientRecorder) InspectContainer(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "InspectContainer", arg0)
}

func (_m *MockDockerClient) ListContainers(_param0 bool) engine.ListContainersResponse {
	ret := _m.ctrl.Call(_m, "ListContainers", _param0)
	ret0, _ := ret[0].(engine.ListContainersResponse)
	return ret0
}

func (_mr *_MockDockerClientRecorder) ListContainers(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "ListContainers", arg0)
}

func (_m *MockDockerClient) PullImage(_param0 string) engine.DockerContainerMetadata {
	ret := _m.ctrl.Call(_m, "PullImage", _param0)
	ret0, _ := ret[0].(engine.DockerContainerMetadata)
	return ret0
}

func (_mr *_MockDockerClientRecorder) PullImage(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "PullImage", arg0)
}

func (_m *MockDockerClient) RemoveContainer(_param0 string) error {
	ret := _m.ctrl.Call(_m, "RemoveContainer", _param0)
	ret0, _ := ret[0].(error)
	return ret0
}

func (_mr *_MockDockerClientRecorder) RemoveContainer(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "RemoveContainer", arg0)
}

func (_m *MockDockerClient) StartContainer(_param0 string) engine.DockerContainerMetadata {
	ret := _m.ctrl.Call(_m, "StartContainer", _param0)
	ret0, _ := ret[0].(engine.DockerContainerMetadata)
	return ret0
}

func (_mr *_MockDockerClientRecorder) StartContainer(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "StartContainer", arg0)
}

func (_m *MockDockerClient) StopContainer(_param0 string) engine.DockerContainerMetadata {
	ret := _m.ctrl.Call(_m, "StopContainer", _param0)
	ret0, _ := ret[0].(engine.DockerContainerMetadata)
	return ret0
}

func (_mr *_MockDockerClientRecorder) StopContainer(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "StopContainer", arg0)
}

func (_m *MockDockerClient) Version() (string, error) {
	ret := _m.ctrl.Call(_m, "Version")
	ret0, _ := ret[0].(string)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

func (_mr *_MockDockerClientRecorder) Version() *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "Version")
}
